module chcase(t3x, char, string, iostream);

object	t[t3x], chr[char], str[string];

const	BUFLEN = 1024;

object	In[iostream], Out[iostream];
var	Inbuf::BUFLEN, Outbuf::BUFLEN;
var	Upcase;

init() do
	In.create(T3X.SYSIN, Inbuf, BUFLEN, IOSTREAM.FREAD);
	Out.create(T3X.SYSOUT, Outbuf, BUFLEN, IOSTREAM.FWRITE);
	Upcase := 0;
end

fini() do
	In.flush();
	Out.flush();
end

locase(s, comm) do var i;
	i := 0;
	while (s::i) do
		if (s::i = ';') do
			if (\comm) return;
			comm := comm-1;
		end
		s::i := chr.lcase(s::i);
		i := i+1;
	end
end

process() do var c, buffer::128, k, i, comm, comm1;
	k := In.reads(buffer, 128);
	comm := 0;
	comm1 := 0;
	while (\In.eof()) do
		ie (buffer::0 = '\n' \/ buffer::0 = '\r')
			comm := 0;
		else ie (\t.memcomp(buffer, "; ---see-also---", 16))
			comm := 1;
		else ie (\t.memcomp(buffer, "; ---example---", 15))
			comm := 1;
		else ie (\t.memcomp(buffer, ";L", 2) \/
			\t.memcomp(buffer, ";l", 2) \/
			\t.memcomp(buffer, ";C", 2) \/
			\t.memcomp(buffer, ";c", 2)
		)
			comm1 := 1;
		else ie (\t.memcomp(buffer, "; ---model---", 13))
			comm := 1;
		else
			;
		locase(buffer, comm|comm1);
		comm1 := 0;
		Out.writes(buffer);
		k := In.reads(buffer, 128);
	end
end

usage() do var umsg;
	umsg := "Usage: chcase [-{lu}]\n";
	t.write(T3X.SYSERR, umsg, str.length(umsg));
	halt 1;
end

do var a::10;
	if (t.getarg(1, a, 10) > 0) do
		ie (a::0 \= '-' \/ a::2) usage();
		else ie (a::1 = 'u') Upcase := 1;
		else ie (a::1 = 'l') Upcase := 0;
		else usage();
	end
	init();
	process();
	fini();
end
