#!/bin/sh

TESTFILE=/tmp/test$$
RUNLOG=/tmp/run$$
LOGFILE=/tmp/log$$

rm -f $LOGFILE; touch $LOGFILE

for file in lib/*.l ext/*.l src/*.l; do

	cat $file >$TESTFILE
	sed -ne '/---example---/,/^$/p' $file \
		| sed -e '1d' -e 's/^;//' >>$TESTFILE
	./alisp -B <$TESTFILE |tee $RUNLOG
	if grep '>>>' $RUNLOG; then
		echo ">>> $file:" >>$LOGFILE
		grep '>>>' $RUNLOG >>$LOGFILE
	fi
done

cat $LOGFILE

rm -f $TESTFILE $RUNLOG $LOGFILE
