; ArrowLISP Core and Library Test

'(quote x)
(quote x)
'(quote (car '(x.y)))
(quote (car '(x.y)))
''x
'x
''(car '(x.y))
'(car '(x.y))

'(cons 'x 'y)
(cons 'x 'y)
'(cons 'x nil)
(cons 'x nil)
'(cons 'x '(y.()))
(cons 'x '(y.()))
'(cons 'x '(y))
(cons 'x '(y))

'(car '(x y))
(car '(x y))
'(car '(x.y))
(car '(x.y))
'(car '(x))
(car '(x))
'(car '#xy)
(car '#xy)
'(car 'x)
(car 'x)
'(car ())
(car ())

'(cdr '(x y))
(cdr '(x y))
'(cdr '(x.y))
(cdr '(x.y))
'(cdr '(x))
(cdr '(x))
'(cdr '#xy)
(cdr '#xy)
'(cdr 'x)
(cdr 'x)
'(cdr ())
(cdr ())

'(atom 'x)
(atom 'x)
'(atom nil)
(atom nil)
'(atom '(x.y))
(atom '(x.y))
'(atom '#x)
(atom '#x)
'(atom '(x y))
(atom '(x y))

'(eq 'x 'x)
(eq 'x 'x)
'(eq x x)
(eq x x)
'(eq nil nil)
(eq nil nil)
'(eq 'x 'y)
(eq 'x 'y)
'(eq 'x '(x.y))
(eq 'x '(x.y))
'(eq '(x.y) '(x.y))
(eq '(x.y) '(x.y))
'((lambda (x) (eq x x)) '(x.y))
((lambda (x) (eq x x)) '(x.y))

'(null nil)
(null nil)
'(null 'x)
(null 'x)
'(null '(x.y))
(null '(x.y))
'(null '(x y))
(null '(x y))

'(cond (*t* 'first) (*t* 'second))
(cond (*t* 'first) (*t* 'second))
'(cond (*t* 'first) (*f* 'second))
(cond (*t* 'first) (*f* 'second))
'(cond (*f* 'first) (*t* 'second))
(cond (*f* 'first) (*t* 'second))
'(cond (*f* 'first) (*f* 'second))
(cond (*f* 'first) (*f* 'second))
'(cond (*f* 'first))
(cond (*f* 'first))
'(cond (t 'first) ((bottom) (bottom)))
(cond (t 'first) ((bottom) (bottom)))
'(cond x y)
(cond x y)
'(cond ('x y))
(cond ('x y))

'(list)
(list)
'(list nil)
(list nil)
'(list 'x)
(list 'x)
'(list (list 'x))
(list (list 'x))
'(list '1 '2)
(list '1 '2)
'(list '1 '2 '3)
(list '1 '2 '3)
'(list '1 '2 '3 '4)
(list '1 '2 '3 '4)
'(list '1 '2 '3 '4 '5)
(list '1 '2 '3 '4 '5)

'(explode nil)
(explode nil)
'(explode 'x)
(explode 'x)
'(explode 'xyz)
(explode 'xyz)
'(explode '(x))
(explode '(x))
'(explode '(x.y))
(explode '(x.y))

'(implode nil)
(implode nil)
'(implode '(X))
(implode '(X))
'(implode '(X Y Z))
(implode '(X Y Z))
'(implode '#ABCDEF)
(implode '#ABCDEF)
'(implode '(X YZ))
(implode '(X YZ))
'(implode 'X)
(implode 'X)

:k on
'(lambda () nil)
(lambda () nil)
'(lambda (x) x)
(lambda (x) x)
'(lambda (x y z) (list x y z))
(lambda (x y z) (list x y z))
'((lambda () nil))
((lambda () nil))
'((lambda (x) x) 'first)
((lambda (x) x) 'first)
'((lambda (x y z) (list x y z)) 'first 'second 'third)
((lambda (x y z) (list x y z)) 'first 'second 'third)
'((lambda #x x) 'first)
((lambda #x x) 'first)
'((lambda #x x))
((lambda #x x))
'((lambda #x x) 'first 'second)
((lambda #x x) 'first 'second)
'(lambda (x) (list x y z) ((y.second) (z.third)))
(lambda (x) (list x y z) ((y.second) (z.third)))
'((lambda (x) (list x y z) ((y.second) (z.third))) 'first)
((lambda (x) (list x y z) ((y.second) (z.third))) 'first)
'(lambda (y) (lambda (x) (cons x y)))
(lambda (y) (lambda (x) (cons x y)))
'((lambda (x) (lambda (y) (cons x y))) 'first)
((lambda (x) (lambda (y) (cons x y))) 'first)
'(((lambda (x) (lambda (y) (cons x y))) 'first) 'second)
(((lambda (x) (lambda (y) (cons x y))) 'first) 'second)
: k off

'(label () nil)
(label () nil)
'(label ((x 'first)) x)
(label ((x 'first)) x)
'(label ((x 'first) (y 'second) (z 'third)) (list x y z))
(label ((x 'first) (y 'second) (z 'third)) (list x y z))
'(label (x) x)
(label (x) x)
'(label ((even-p (lambda (x)
		(cond ((null x) *t*)
			(t (odd-p (cdr x))))))
	(odd-p (lambda (x)
		(cond ((null x) *f*)
			(t (even-p (cdr x)))))))
	(list (odd-p '#iiiii) (even-p '#iiiii)))
(label ((even-p (lambda (x)
		(cond ((null x) *t*)
			(t (odd-p (cdr x))))))
	(odd-p (lambda (x)
		(cond ((null x) *f*)
			(t (even-p (cdr x)))))))
	(list (odd-p '#iiiii) (even-p '#iiiii)))


'some-function
some-function
'(defun some-function (x y z) (list x y z))
(defun some-function (x y z) (list x y z))
'some-function
some-function
'(some-function 'first 'second 'third)
(some-function 'first 'second 'third)

'some-symbol
some-symbol
'(define some-symbol some-function)
(define some-symbol some-function)
'some-symbol
some-symbol
'(some-symbol 'first 'second 'third)
(some-symbol 'first 'second 'third)
'(define some-symbol 'some-function)
(define some-symbol 'some-function)
'some-symbol
some-symbol
'(define some-symbol
	(lambda (x y) (cond ((null x) y) (t (some-symbol (cdr x) (cons '1 y))))))
(define some-symbol
	(lambda (x y) (cond ((null x) y) (t (some-symbol (cdr x) (cons '1 y))))))
'some-symbol
some-symbol
'(some-symbol '#hello-world nil)
(some-symbol '#hello-world nil)

'(eval '(cons 'a 'b))
(eval '(cons 'a 'b))
'(eval '(car '(a.b)))
(eval '(car '(a.b)))
'(eval '(cdr '(a.b)))
(eval '(cdr '(a.b)))

'(bottom)
(bottom)
'(bottom 'x 'y 'z)
(bottom 'x 'y 'z)
'(eq (bottom 'x) 'x)
(eq (bottom 'x) 'x)

'((car ((lambda (x) (list (lambda () x))) 'foo)))
((car ((lambda (x) (list (lambda () x))) 'foo)))

'(call/cc (lambda (k) 'foo))
(call/cc (lambda (k) 'foo))
'(cons 'foo (call/cc (lambda (k) (k 'bar))))
(cons 'foo (call/cc (lambda (k) (k 'bar))))
'(cons 'foo (call/cc (lambda (k) (cons 'zzz (k 'bar)))))
(cons 'foo (call/cc (lambda (k) (cons 'zzz (k 'bar)))))
'((call/cc call/cc) (lambda (x) x))
((call/cc call/cc) (lambda (x) x))
'((call/cc (lambda (x) x)) (lambda (x) x))
((call/cc (lambda (x) x)) (lambda (x) x))

(defun procedure-p (x) (cond ((atom x) *f*)
		((eq (car x) 'continuation) t)
		(t (eq (car x) 'lambda))))

(defun pair-p (x) (cond ((atom x) *f*)
	((procedure-p x) *f*)
	(t t)))

'(label ((x (call/cc (lambda (x) x))))
	(cond ((procedure-p x) (x 'foo))
		(t x)))
(label ((x (call/cc (lambda (x) x))))
	(cond ((procedure-p x) (x 'foo))
		(t x)))

'((lambda (x)
   (cond ((pair-p x) ((car x) (lambda () x)))
       (t (pair-p (x)))))
 (call/cc list))
((lambda (x)
   (cond ((pair-p x) ((car x) (lambda () x)))
       (t (pair-p (x)))))
 (call/cc list))

'(label
	((k1 (lambda (x)
		(cond ((procedure-p x) (x *f*))
			(t ((lambda (ignored) (pair-p x))
				(label ((k2 (lambda (y) y)))
					(k2 (car x)))))))))
	(k1 (list k1)))
(label
	((k1 (lambda (x)
		(cond ((procedure-p x) (x *f*))
			(t ((lambda (ignored) (pair-p x))
				(label ((k2 (lambda (y) y)))
					(k2 (car x)))))))))
	(k1 (list k1)))

'((lambda (k1) (k1 (list k1)))
	(lambda (x) (cond ((procedure-p x) (x *f*))
			(t ((lambda (ignored) (pair-p x))
				((lambda (k2) (k2 (car x)))
					(lambda (y) y)))))))
((lambda (k1) (k1 (list k1)))
	(lambda (x) (cond ((procedure-p x) (x *f*))
			(t ((lambda (ignored) (pair-p x))
				((lambda (k2) (k2 (car x)))
					(lambda (y) y)))))))

'(label
	((x (call/cc list))
	(y (call/cc list)))
(cond ((procedure-p x) (x (pair-p y)))
	((procedure-p y) (y (pair-p x)))
	((call/cc (car x)) (call/cc (car y)))
	(t *f*)))
(label
	((x (call/cc list))
	(y (call/cc list)))
(cond ((procedure-p x) (x (pair-p y)))
	((procedure-p y) (y (pair-p x)))
	((call/cc (car x)) (call/cc (car y)))
	(t *f*)))

:l lib/alisp.l

(define slist1 '(a b c d e f g h i j))
(define slist2 '(z y x w v u t s r q))

(define nlist '((1 0) (5) (2 5) (1 9) (9) (1 0 1) (7 7) (0) (3 3) (4 5)))
(define olist '((0) (5) (9) (1 0) (1 9) (2 5) (3 3) (4 5) (7 7) (1 0 1)))

(define ilist '((- 7 7) (- 2 5) (+ 1 0) (+ 5) (+ 1 9) (+ 9) (+ 1 0 1)
	(+ 0) (+ 3 3) (+ 4 5)))

(define rlist '((/ #7 #8) (/ #2 #3) (/ #8 #9) (/ #5 #6) (/ #1 #2)
	(/ #4 #5) (/ #9 #10) (/ #6 #7) (/ #3 #4)))

(define set1 slist1)
(define set2 '(f g h i j k l m n o p))

(define plist1 '(i ii iii iv v vi vii viii ix x))
(define plist2 '(1 2 3 4 5 6 7 8 9 10))

(define alist '((i.1) (ii.2) (iii.3) (iv.4) (v.5) (vi.6) (vii.7) (viii.8)
	(ix.9) (x.10)))

(define clist1 '(((a b) (c d) e) ((f g) (h i)) ((j k) (l m)) n))
(define clist2 '(((a b) (c d) x) ((f g) (h i)) ((j k) (l m)) n))

(define num1 '(5 5 5 5 5))
(define num2 '(7 7 7))

(define int1 '(+ 5 5 5 5 5))
(define int2 '(+ 7 7 7))
(define int1n '(- 5 5 5 5 5))
(define int2n '(- 7 7 7))

(define rat1 '(/ #17 #23))
(define rat2 '(/ #23 #17))
(define rat1n '(/ #-17 #23))
(define rat2n '(/ #-23 #17))

(define date1 '(#2001 #7 #10))
(define date2 '(#2001 #7 #11))
(define date3 '(#2001 #10 #02))
(define date4 '(#2010 #1 #01))

(define xlist '(symbol (5 5 5) (list with members) (1 2 3)
	(car (some expr))))

(define expr '(symbol (5 5 5) ((a.b) (c.d)) (list with members) (1 2 3)
	(car (some expr))))

(define tree '(
	((() #1 (() #2 ())) #3 (() #4 ())) #5 (((() #7 ()) #8 ()) #9 ())))

(define atree '(
	((() (#1.one) (() (#2.two) ())) (#3.three) (() (#4.four) ())) (#5.five)
	(((() (#7.seven) ()) (#8.eight) ()) (#9.nine) ())))

'(abs num1)
(abs num1)
'(abs int1)
(abs int1)
'(abs int1n)
(abs int1n)
'(abs rat1)
(abs rat1)
'(abs rat1n)
(abs rat1n)

'(any '((a b c) x (d e f)) atom)
(any '((a b c) x (d e f)) atom)
'(any '((a b c) (d e f)) atom)
(any '((a b c) (d e f)) atom)
'(any () atom)
(any () atom)

'(append slist1 slist2)
(append slist1 slist2)
'(append slist1 nil)
(append slist1 nil)
'(append nil slist1)
(append nil slist1)
'(append nil nil)
(append nil nil)

'(apply cons '('a 'b))
(apply cons '('a 'b))
'(apply (lambda () 'x) nil)
(apply (lambda () 'x) nil)
'(apply explode '('hello-world!))
(apply explode '('hello-world!))

'(assoc 'vii alist)
(assoc 'vii alist)
'(assoc 'xxx alist)
(assoc 'xxx alist)
'(assoc 'xxx nil)
(assoc 'xxx nil)

; (caaaar clist1)
; (caaadr clist1)
; (caadar clist1)
; (caaddr clist1)
; (cadaar clist1)
; (cadadr clist1)
; (caddar clist1)
; (cadddr clist1)
; (cdaaar clist1)
; (cdaadr clist1)
; (cdadar clist1)
; (cdaddr clist1)
; (cddaar clist1)
; (cddadr clist1)
; (cdddar clist1)
; (cddddr clist1)

'(caaar clist1)
(caaar clist1)
'(caadr clist1)
(caadr clist1)
'(cadar clist1)
(cadar clist1)
'(caddr clist1)
(caddr clist1)
'(cdaar clist1)
(cdaar clist1)
'(cdadr clist1)
(cdadr clist1)
'(cddar clist1)
(cddar clist1)
'(cdddr clist1)
(cdddr clist1)

'(caar clist1)
(caar clist1)
'(cadr clist1)
(cadr clist1)
'(cdar clist1)
(cdar clist1)
'(cddr clist1)
(cddr clist1)

'(copy 'x)
(copy 'x)
'(copy '(a.b))
(copy '(a.b))
'(copy slist1)
(copy slist1)
'(copy expr)
(copy expr)
'(copy nil)
(copy nil)

'(count ())
(count ())
'(count 'x)
(count 'x)
'(count '(x))
(count '(x))
'(count '(x.y))
(count '(x.y))
'(count expr)
(count expr)

'(decr '#100)
(decr '#100)
'(decr '#1)
(decr '#1)
'(decr '#0)
(decr '#0)

'(denominator rat1)
(denominator rat1)
'(denominator rat2)
(denominator rat2)
'(denominator rat1n)
(denominator rat1n)
'(denominator rat2n)
(denominator rat2n)

'(depth nil)
(depth nil)
'(depth 'x)
(depth 'x)
'(depth clist1)
(depth clist1)
'(depth '(((((x))))))
(depth '(((((x))))))
'(depth '(1 (2 (3) 2) 1))
(depth '(1 (2 (3) 2) 1))

'(difference num1 num2)
(difference num1 num2)
'(difference num2 num1)
(difference num2 num1)
'(difference num2 '(0))
(difference num2 '(0))

'digits
0 1 2 3 4 5 6 7 8 9

'(divide num1 num2)
(divide num1 num2)
'(divide num2 num1)
(divide num2 num1)
'(divide num1 '(1))
(divide num1 '(1))
'(divide num1 '(0))
(divide num1 '(0))

'(equal clist1 clist1)
(equal clist1 clist1)
'(equal clist1 clist2)
(equal clist1 clist2)

'(equalize rat1 rat1)
(equalize rat1 rat1)
'(equalize rat1 rat1n)
(equalize rat1 rat1n)
'(equalize rat1 rat2)
(equalize rat1 rat2)
'(equalize rat1 rat2n)
(equalize rat1 rat2n)
'(equalize rat1n rat2n)
(equalize rat1n rat2n)

'(evenp '#100)
(evenp '#100)
'(evenp '#101)
(evenp '#101)
'(evenp '#-102)
(evenp '#-102)
'(evenp '#-103)
(evenp '#-103)
'(evenp '#104)
(evenp '#104)
'(evenp '#105)
(evenp '#105)
'(evenp '#106)
(evenp '#106)
'(evenp '#-107)
(evenp '#-107)
'(evenp '#-108)
(evenp '#-108)
'(evenp '#-109)
(evenp '#-109)
'(evenp '(/ #2 #1))
(evenp '(/ #2 #1))
'(evenp '(/ #2 #3))
(evenp '(/ #2 #3))

'(every '(a b c d e f) atom)
(every '(a b c d e f) atom)
'(every '(a b c (x.y) d e f) atom)
(every '(a b c (x.y) d e f) atom)
'(every () atom)
(every () atom)

'(expt '(2) '(0))
(expt '(2) '(0))
'(expt '(2) '(1))
(expt '(2) '(1))
'(expt '(2) '(1 6))
(expt '(2) '(1 6))

'(fac '(0))
(fac '(0))
'(fac '(9))
(fac '(9))
'(fac '(+ 0))
(fac '(+ 0))
'(fac '(+ 9))
(fac '(+ 9))
'(fac '(- 1))
(fac '(- 1))

'(filter xlist numberp)
(filter xlist numberp)
'(filter nil null)
(filter nil null)

'(gcd '(2 8 9) '(3 4))
(gcd '(2 8 9) '(3 4))
'(gcd '(3 4) '(2 8 9))
(gcd '(3 4) '(2 8 9))
'(gcd '(+ 2 8 9) '(+ 3 4))
(gcd '(+ 2 8 9) '(+ 3 4))
'(gcd '(+ 3 4) '(+ 2 8 9))
(gcd '(+ 3 4) '(+ 2 8 9))

'(greaterp num1 num2)
(greaterp num1 num2)
'(greaterp num2 num1)
(greaterp num2 num1)
'(greaterp num2 num2)
(greaterp num2 num2)

'(headp () '(a b c))
(headp () '(a b c))
'(headp '(a b c) '(a b c d e f))
(headp '(a b c) '(a b c d e f))
'(headp '(a c) '(a b c d e f))
(headp '(a c) '(a b c d e f))
'(headp '(a b c) '(a b c))
(headp '(a b c) '(a b c))
'(headp '(a b c d) '(a b c))
(headp '(a b c d) '(a b c))
'(headp '((a) ((b)) (c)) '((a) ((b)) (c) (d)))
(headp '((a) ((b)) (c)) '((a) ((b)) (c) (d)))

'(hyper '#0 '#3 '#3)
(hyper '#0 '#3 '#3)
'(hyper '#1 '#3 '#3)
(hyper '#1 '#3 '#3)
'(hyper '#2 '#3 '#3)
(hyper '#2 '#3 '#3)
'(hyper '#3 '#3 '#3)
(hyper '#3 '#3 '#3)
'(hyper '#4 '#3 '#3)
(hyper '#4 '#3 '#3)
'(hyper '#100 '#2 '#2)
(hyper '#100 '#2 '#2)

'(id nil)
(id nil)
'(id 'foo)
(id 'foo)
'(id expr)
(id expr)

'(idifference int1 int2)
(idifference int1 int2)
'(idifference int1 int2n)
(idifference int1 int2n)
'(idifference int1n int2)
(idifference int1n int2)
'(idifference int1n int2n)
(idifference int1n int2n)
'(idifference int2 int1)
(idifference int2 int1)
'(idifference int2 int1n)
(idifference int2 int1n)
'(idifference int2n int1)
(idifference int2n int1)
'(idifference int2n int1n)
(idifference int2n int1n)

'(iexpt '(+ 2) '(+ 0))
(iexpt '(+ 2) '(+ 0))
'(iexpt '(+ 2) '(+ 1))
(iexpt '(+ 2) '(+ 1))
'(iexpt '(+ 2) '(+ 1 6))
(iexpt '(+ 2) '(+ 1 6))
'(iexpt '(+ 2) '(- 2))
(iexpt '(+ 2) '(- 2))
'(iexpt '(- 2) '(+ 2))
(iexpt '(- 2) '(+ 2))
'(iexpt '(- 2) '(+ 3))
(iexpt '(- 2) '(+ 3))

'(igreaterp int1 int2)
(igreaterp int1 int2)
'(igreaterp int1 int2n)
(igreaterp int1 int2n)
'(igreaterp int1n int2)
(igreaterp int1n int2)
'(igreaterp int1n int2n)
(igreaterp int1n int2n)
'(igreaterp int2 int1)
(igreaterp int2 int1)
'(igreaterp int2 int1n)
(igreaterp int2 int1n)
'(igreaterp int2n int1)
(igreaterp int2n int1)
'(igreaterp int2n int1n)
(igreaterp int2n int1n)
'(igreaterp int2 int2)
(igreaterp int2 int2)
'(igreaterp int2n int2n)
(igreaterp int2n int2n)

'(ilessp int1 int2)
(ilessp int1 int2)
'(ilessp int1 int2n)
(ilessp int1 int2n)
'(ilessp int1n int2)
(ilessp int1n int2)
'(ilessp int1n int2n)
(ilessp int1n int2n)
'(ilessp int2 int1)
(ilessp int2 int1)
'(ilessp int2 int1n)
(ilessp int2 int1n)
'(ilessp int2n int1)
(ilessp int2n int1)
'(ilessp int2n int1n)
(ilessp int2n int1n)
'(ilessp int1 int1)
(ilessp int1 int1)
'(ilessp int1n int1n)
(ilessp int1n int1n)

'(imax '(#-5))
(imax '(#-5))
'(imax ilist)
(imax ilist)

'(imin '(#-5))
(imin '(#-5))
'(imin ilist)
(imin ilist)

'(incr '#0)
(incr '#0)
'(incr '#99)
(incr '#99)

'(ingreaterp int1 int2)
(ingreaterp int1 int2)
'(ingreaterp int1 int2n)
(ingreaterp int1 int2n)
'(ingreaterp int1n int2)
(ingreaterp int1n int2)
'(ingreaterp int1n int2n)
(ingreaterp int1n int2n)
'(ingreaterp int2 int1)
(ingreaterp int2 int1)
'(ingreaterp int2 int1n)
(ingreaterp int2 int1n)
'(ingreaterp int2n int1)
(ingreaterp int2n int1)
'(ingreaterp int2n int1n)
(ingreaterp int2n int1n)
'(ingreaterp int2 int2)
(ingreaterp int2 int2)
'(ingreaterp int2n int2n)
(ingreaterp int2n int2n)

'(inlessp int1 int2)
(inlessp int1 int2)
'(inlessp int1 int2n)
(inlessp int1 int2n)
'(inlessp int1n int2)
(inlessp int1n int2)
'(inlessp int1n int2n)
(inlessp int1n int2n)
'(inlessp int2 int1)
(inlessp int2 int1)
'(inlessp int2 int1n)
(inlessp int2 int1n)
'(inlessp int2n int1)
(inlessp int2n int1)
'(inlessp int2n int1n)
(inlessp int2n int1n)
'(inlessp int1 int1)
(inlessp int1 int1)
'(inlessp int1n int1n)
(inlessp int1n int1n)

'(insert '(5 3) olist lessp)
(insert '(5 3) olist lessp)

'(integer rat1)
(integer rat1)
'(integer '(/ #20 #5))
(integer '(/ #20 #5))
'(integer int1n)
(integer int1n)
'(integer num1)
(integer num1)

'(integer int1)
(integer int1)
'(integer int1n)
(integer int1n)
'(integer num1)
(integer num1)

'(integerp int1)
(integerp int1)
'(integerp int1n)
(integerp int1n)
'(integerp num1)
(integerp num1)

'(intersection set1 set2)
(intersection set1 set2)
'(intersection set1 nil)
(intersection set1 nil)
'(intersection nil set2)
(intersection nil set2)
'(intersection nil nil)
(intersection nil nil)

'(iota '#0)
(iota '#0)
'(iota '#10)
(iota '#10)
'(iota '#-10)
(iota '#-10)

'(iplus int1 int2)
(iplus int1 int2)
'(iplus int1 int2n)
(iplus int1 int2n)
'(iplus int1n int2)
(iplus int1n int2)
'(iplus int1n int2n)
(iplus int1n int2n)
'(iplus int2 int1)
(iplus int2 int1)
'(iplus int2 int1n)
(iplus int2 int1n)
'(iplus int2n int1)
(iplus int2n int1)
'(iplus int2n int1n)
(iplus int2n int1n)

'(iquotient int1 int2)
(iquotient int1 int2)
'(iquotient int1 int2n)
(iquotient int1 int2n)
'(iquotient int1n int2)
(iquotient int1n int2)
'(iquotient int1n int2n)
(iquotient int1n int2n)
'(iquotient int2 int1)
(iquotient int2 int1)
'(iquotient int2 int1n)
(iquotient int2 int1n)
'(iquotient int2n int1)
(iquotient int2n int1)
'(iquotient int2n int1n)
(iquotient int2n int1n)
'(iquotient num1 num2)
(iquotient num1 num2)
'(iquotient num1 int2)
(iquotient num1 int2)
'(iquotient num1 int2n)
(iquotient num1 int2n)
'(iquotient int1n num2)
(iquotient int1n num2)

'(iremainder int1 int2)
(iremainder int1 int2)
'(iremainder int1 int2n)
(iremainder int1 int2n)
'(iremainder int1n int2)
(iremainder int1n int2)
'(iremainder int1n int2n)
(iremainder int1n int2n)
'(iremainder int2 int1)
(iremainder int2 int1)
'(iremainder int2 int1n)
(iremainder int2 int1n)
'(iremainder int2n int1)
(iremainder int2n int1)
'(iremainder int2n int1n)
(iremainder int2n int1n)
'(iremainder num1 num2)
(iremainder num1 num2)
'(iremainder num1 int2)
(iremainder num1 int2)
'(iremainder num1 int2n)
(iremainder num1 int2n)
'(iremainder int1n num2)
(iremainder int1n num2)

'(isort nlist greaterp)
(isort nlist greaterp)
'(isort nlist lessp)
(isort nlist lessp)
'(isort nil lessp)
(isort nil lessp)

'(itimes int1 int2)
(itimes int1 int2)
'(itimes int1 int2n)
(itimes int1 int2n)
'(itimes int1n int2)
(itimes int1n int2)
'(itimes int1n int2n)
(itimes int1n int2n)
'(itimes int2 int1)
(itimes int2 int1)
'(itimes int2 int1n)
(itimes int2 int1n)
'(itimes int2n int1)
(itimes int2n int1)
'(itimes int2n int1n)
(itimes int2n int1n)
'(itimes num1 num2)
(itimes num1 num2)
'(itimes num1 int2)
(itimes num1 int2)
'(itimes num1 int2n)
(itimes num1 int2n)
'(itimes int1n num2)
(itimes int1n num2)

'(last expr)
(last expr)
'(last '(x))
(last '(x))

'(length clist1)
(length clist1)
'(length nlist)
(length nlist)
'(length xlist)
(length xlist)

'(lessp num1 num2)
(lessp num1 num2)
'(lessp num2 num1)
(lessp num2 num1)
'(lessp num1 num1)
(lessp num1 num1)

'(listp expr)
(listp expr)
'(listp nil)
(listp nil)
'(listp '(x))
(listp '(x))
'(listp '(a.b))
(listp '(a.b))
'(listp 'x)
(listp 'x)

'(litatom 'x)
(litatom 'x)
'(litatom '(x y))
(litatom '(x y))
'(litatom ())
(litatom ())

'(logand *f* *f*)
(logand *f* *f*)
'(logand *t* *f*)
(logand *t* *f*)
'(logand *f* *t*)
(logand *f* *t*)
'(logand *t* *t*)
(logand *t* *t*)

'(logeqv *f* *f*)
(logeqv *f* *f*)
'(logeqv *t* *f*)
(logeqv *t* *f*)
'(logeqv *f* *t*)
(logeqv *f* *t*)
'(logeqv *t* *t*)
(logeqv *t* *t*)

'(lognand *f* *f*)
(lognand *f* *f*)
'(lognand *t* *f*)
(lognand *t* *f*)
'(lognand *f* *t*)
(lognand *f* *t*)
'(lognand *t* *t*)
(lognand *t* *t*)

'(logneqv *f* *f*)
(logneqv *f* *f*)
'(logneqv *t* *f*)
(logneqv *t* *f*)
'(logneqv *f* *t*)
(logneqv *f* *t*)
'(logneqv *t* *t*)
(logneqv *t* *t*)

'(lognor *f* *f*)
(lognor *f* *f*)
'(lognor *t* *f*)
(lognor *t* *f*)
'(lognor *f* *t*)
(lognor *f* *t*)
'(lognor *t* *t*)
(lognor *t* *t*)

'(logor *f* *f*)
(logor *f* *f*)
'(logor *t* *f*)
(logor *t* *f*)
'(logor *f* *t*)
(logor *f* *t*)
'(logor *t* *t*)
(logor *t* *t*)

'(lognot *f*)
(lognot *f*)
'(lognot *t*)
(lognot *t*)

'(map olist olist plus)
(map olist olist plus)

'(mapcar nlist numberp)
(mapcar nlist numberp)

'(maplis slist1 reverse)
(maplis slist1 reverse)

'(max '(#5))
(max '(#5))
'(max nlist)
(max nlist)

'(memb 'h slist1)
(memb 'h slist1)
'(memb 'x slist1)
(memb 'x slist1)
'(memb 'a nil)
(memb 'a nil)

'(member '(iv.4) alist)
(member '(iv.4) alist)
'(member '(iv.5) alist)
(member '(iv.5) alist)
'(member '(iv.4) nil)
(member '(iv.4) nil)

'(min '(#5))
(min '(#5))
'(min nlist)
(min nlist)

'(minus rat1)
(minus rat1)
'(minus rat1n)
(minus rat1n)
'(minus int1)
(minus int1)
'(minus int1n)
(minus int1n)
'(minus num1)
(minus num1)
'(minus '#0)
(minus '#0)

'(minusp rat1)
(minusp rat1)
'(minusp rat1n)
(minusp rat1n)
'(minusp int1)
(minusp int1)
'(minusp int1n)
(minusp int1n)
'(minusp num1)
(minusp num1)

'(natural num1)
(natural num1)
'(natural int1)
(natural int1)
'(natural int1n)
(natural int1n)
'(natural rat1)
(natural rat1)
'(natural '(/ #20 #4))
(natural '(/ #20 #4))
'(natural '(/ #-20 #4))
(natural '(/ #-20 #4))

'(naturalp num1)
(naturalp num1)
'(naturalp int1)
(naturalp int1)
'(naturalp int1n)
(naturalp int1n)

'(neq 'a 'a)
(neq 'a 'a)
'(neq 'a 'b)
(neq 'a 'b)

'(nequal clist1 clist1)
(nequal clist1 clist1)
'(nequal clist1 clist2)
(nequal clist1 clist2)

'(ngreaterp num1 num2)
(ngreaterp num1 num2)
'(ngreaterp num2 num1)
(ngreaterp num2 num1)
'(ngreaterp num2 num2)
(ngreaterp num2 num2)

'(nlessp num1 num2)
(nlessp num1 num2)
'(nlessp num2 num1)
(nlessp num2 num1)
'(nlessp num1 num1)
(nlessp num1 num1)

'(normalize (append '(0 0 0 0 0) num1))
(normalize (append '(0 0 0 0 0) num1))
'(normalize (append '(+ 0 0 0 0 0) (cdr int1)))
(normalize (append '(+ 0 0 0 0 0) (cdr int1)))
'(normalize (append '(- 0 0 0 0 0) (cdr int1)))
(normalize (append '(- 0 0 0 0 0) (cdr int1)))
'(normalize '(/ #000200 #0016))
(normalize '(/ #000200 #0016))
'(normalize '(/ #200 #16))
(normalize '(/ #200 #16))
'(normalize '(/ #-200 #16))
(normalize '(/ #-200 #16))
'(normalize '(/ #200 #-16))
(normalize '(/ #200 #-16))
'(normalize '(/ #-200 #-16))
(normalize '(/ #-200 #-16))
'(normalize '(/ #256 #-16))
(normalize '(/ #256 #-16))
'(normalize '(/ #256 #16))
(normalize '(/ #256 #16))

'(nth slist1 '#1)
(nth slist1 '#1)
'(nth slist1 '#5)
(nth slist1 '#5)
'(nth slist1 '#13)
(nth slist1 '#13)
'(nth slist1 '#14)
(nth slist1 '#14)
'(nth slist1 '#0)
(nth slist1 '#0)
'(nth () '#1)
(nth () '#1)

'(numberp num1)
(numberp num1)
'(numberp int1)
(numberp int1)
'(numberp int1n)
(numberp int1n)
'(numberp rat1)
(numberp rat1)
'(numberp rat1n)
(numberp rat1n)
'(numberp '(/ #-1 #-1))
(numberp '(/ #-1 #-1))
'(numberp clist1)
(numberp clist1)

'(numerator rat1)
(numerator rat1)
'(numerator rat2)
(numerator rat2)
'(numerator rat1n)
(numerator rat1n)
'(numerator rat2n)
(numerator rat2n)

'o
o

'(oddp '#100)
(oddp '#100)
'(oddp '#101)
(oddp '#101)
'(oddp '#-102)
(oddp '#-102)
'(oddp '#-103)
(oddp '#-103)
'(oddp '#104)
(oddp '#104)
'(oddp '#105)
(oddp '#105)
'(oddp '#106)
(oddp '#106)
'(oddp '#-107)
(oddp '#-107)
'(oddp '#-108)
(oddp '#-108)
'(oddp '#-109)
(oddp '#-109)
'(oddp '(/ #2 #1))
(oddp '(/ #2 #1))
'(oddp '(/ #2 #3))
(oddp '(/ #2 #3))

'(onep '#0)
(onep '#0)
'(onep '#1)
(onep '#1)
'(onep '#+1)
(onep '#+1)
'(onep '#+25)
(onep '#+25)
'(onep '#-1)
(onep '#-1)
'(onep rat1)
(onep rat1)
'(onep '(/ #1 #2))
(onep '(/ #1 #2))
'(onep '(/ #2 #2))
(onep '(/ #2 #2))
'(onep '(/ #-2 #2))
(onep '(/ #-2 #2))

'(orderedp olist lessp)
(orderedp olist lessp)
'(orderedp nlist lessp)
(orderedp nlist lessp)
'(orderedp nill lessp)
(orderedp nil lessp)

'(pair plist1 plist2)
(pair plist1 plist2)
'(pair nil nil)
(pair nil nil)

'(pairp '(x.y))
(pairp '(x.y))
'(pairp '(x))
(pairp '(x))
'(pairp expr)
(pairp expr)
'(pairp 'x)
(pairp nil)
'(pairp nil)
(pairp 'x)

'(permute '(a b c))
(permute '(a b c))
'(permute '(a a b))
(permute '(a a b))
'(permute '(a a a))
(permute '(a a a))
'(permute nil)
(permute nil)

'(plus num1 num2)
(plus num1 num2)
'(plus num2 num1)
(plus num2 num1)
'(plus num2 '(0))
(plus num2 '(0))

'(plusp int1)
(plusp int1)
'(plusp int1n)
(plusp int1n)
'(plusp rat1)
(plusp rat1)
'(plusp rat1n)
(plusp rat1n)
'(plusp '#0)
(plusp '#0)
'(plusp num1)
(plusp num1)

'(pred 5)
(pred 5)
'(pred 0)
(pred 0)

'(product '#1 '#10)
(product '#1 '#10)
'(product '#+1 '#+10)
(product '#+1 '#+10)
'(product '#5 '#15)
(product '#5 '#15)
'(product '#-1 '#-10)
(product '#-1 '#-10)
'(product '#10 '#1)
(product '#10 '#1)

'(quicksort nlist greaterp)
(quicksort nlist greaterp)
'(quicksort nlist lessp)
(quicksort nlist lessp)
'(quicksort nil lessp)
(quicksort nil lessp)

'(quotient num1 num2)
(quotient num1 num2)
'(quotient num2 num1)
(quotient num2 num1)

'(rational rat1)
(rational rat1)
'(rational rat1n)
(rational rat1n)
'(rational int1)
(rational int1)
'(rational int1n)
(rational int1n)
'(rational num1)
(rational num1)

'(rationalp rat1)
(rationalp rat1)
'(rationalp rat1n)
(rationalp rat1n)
'(rationalp int1)
(rationalp int1)
'(rationalp int1n)
(rationalp int1n)
'(rationalp num1)
(rationalp num1)

'(rdifference rat1 rat2)
(rdifference rat1 rat2)
'(rdifference rat1 rat2n)
(rdifference rat1 rat2n)
'(rdifference rat1n rat2)
(rdifference rat1n rat2)
'(rdifference rat1n rat2n)
(rdifference rat1n rat2n)
'(rdifference rat2 rat1)
(rdifference rat2 rat1)
'(rdifference rat2 rat1n)
(rdifference rat2 rat1n)
'(rdifference rat2n rat1)
(rdifference rat2n rat1)
'(rdifference rat2n rat1n)
(rdifference rat2n rat1n)
'(rdifference int1 int2)
(rdifference int1 int2)
'(rdifference int1 int2n)
(rdifference int1 int2n)
'(rdifference int1n int2)
(rdifference int1n int2)
'(rdifference int1n int2n)
(rdifference int1n int2n)
'(rdifference int2 int1)
(rdifference int2 int1)
'(rdifference int2 int1n)
(rdifference int2 int1n)
'(rdifference int2n int1)
(rdifference int2n int1)
'(rdifference int2n int1n)
(rdifference int2n int1n)
'(rdifference num1 num2)
(rdifference num1 num2)
'(rdifference num2 num1)
(rdifference num2 num1)

'(reduce slist1 nil cons)
(reduce slist1 nil cons)
'(reduce nil nil cons)
(reduce nil nil cons)

'(remainder num1 num2)
(remainder num1 num2)
'(remainder num2 num1)
(remainder num2 num1)

'(remove xlist numberp)
(remove xlist numberp)
'(remove nil null)
(remove nil null)

'(reverse clist1)
(reverse clist1)
'(reverse olist)
(reverse olist)
'(reverse nil)
(reverse nil)

'(rexpt '#2 '#0)
(rexpt '#2 '#0)
'(rexpt '#2 '#1)
(rexpt '#2 '#1)
'(rexpt '#2 '#16)
(rexpt '#2 '#8)
'(rexpt '#2 '#-1)
(rexpt '#2 '#-1)
'(rexpt '#2 '#-8)
(rexpt '#2 '#-8)
'(rexpt '(/ #1 #2) '#-8)
(rexpt '(/ #1 #2) '#-8)
'(rexpt '(/ #2 #3) '#-3)
(rexpt '(/ #2 #3) '#-3)
'(rexpt '(/ #-2 #3) '#3)
(rexpt '(/ #-2 #3) '#3)
'(rexpt '(/ #-2 #3) '#-3)
(rexpt '(/ #-2 #3) '#-3)

'(rgreaterp rat1 rat2)
(rgreaterp rat1 rat2)
'(rgreaterp rat1 rat2n)
(rgreaterp rat1 rat2n)
'(rgreaterp rat1n rat2)
(rgreaterp rat1n rat2)
'(rgreaterp rat1n rat2n)
(rgreaterp rat1n rat2n)
'(rgreaterp rat2 rat1)
(rgreaterp rat2 rat1)
'(rgreaterp rat2 rat1n)
(rgreaterp rat2 rat1n)
'(rgreaterp rat2n rat1)
(rgreaterp rat2n rat1)
'(rgreaterp rat2n rat1n)
(rgreaterp rat2n rat1n)
'(rgreaterp rat2 rat2)
(rgreaterp rat2 rat2)
'(rgreaterp rat2n rat2n)
(rgreaterp rat2n rat2n)
'(rgreaterp int1 int2)
(rgreaterp int1 int2)
'(rgreaterp int2n int1n)
(rgreaterp int2n int1n)
'(rgreaterp num1 num2)
(rgreaterp num1 num2)
'(rgreaterp num2 num1)
(rgreaterp num2 num1)

'(rlessp rat1 rat2)
(rlessp rat1 rat2)
'(rlessp rat1 rat2n)
(rlessp rat1 rat2n)
'(rlessp rat1n rat2)
(rlessp rat1n rat2)
'(rlessp rat1n rat2n)
(rlessp rat1n rat2n)
'(rlessp rat2 rat1)
(rlessp rat2 rat1)
'(rlessp rat2 rat1n)
(rlessp rat2 rat1n)
'(rlessp rat2n rat1)
(rlessp rat2n rat1)
'(rlessp rat2n rat1n)
(rlessp rat2n rat1n)
'(rlessp rat2 rat2)
(rlessp rat2 rat2)
'(rlessp rat2n rat2n)
(rlessp rat2n rat2n)
'(rlessp int1 int2)
(rlessp int1 int2)
'(rlessp int2n int1n)
(rlessp int2n int1n)
'(rlessp num1 num2)
(rlessp num1 num2)
'(rlessp num2 num1)
(rlessp num2 num1)

'(rmax '((/ #2 #3)))
(rmax '((/ #2 #3)))
'(rmax rlist)
(rmax rlist)

'(rmin '((/ #2 #3)))
(rmin '((/ #2 #3)))
'(rmin rlist)
(rmin rlist)

'(rngreaterp rat1 rat2)
(rngreaterp rat1 rat2)
'(rngreaterp rat1 rat2n)
(rngreaterp rat1 rat2n)
'(rngreaterp rat1n rat2)
(rngreaterp rat1n rat2)
'(rngreaterp rat1n rat2n)
(rngreaterp rat1n rat2n)
'(rngreaterp rat2 rat1)
(rngreaterp rat2 rat1)
'(rngreaterp rat2 rat1n)
(rngreaterp rat2 rat1n)
'(rngreaterp rat2n rat1)
(rngreaterp rat2n rat1)
'(rngreaterp rat2n rat1n)
(rngreaterp rat2n rat1n)
'(rngreaterp rat2 rat2)
(rngreaterp rat2 rat2)
'(rngreaterp rat2n rat2n)
(rngreaterp rat2n rat2n)
'(rngreaterp int1 int2)
(rngreaterp int1 int2)
'(rngreaterp int2n int1n)
(rngreaterp int2n int1n)
'(rngreaterp num1 num2)
(rngreaterp num1 num2)
'(rngreaterp num2 num1)
(rngreaterp num2 num1)

'(rnlessp rat1 rat2)
(rnlessp rat1 rat2)
'(rnlessp rat1 rat2n)
(rnlessp rat1 rat2n)
'(rnlessp rat1n rat2)
(rnlessp rat1n rat2)
'(rnlessp rat1n rat2n)
(rnlessp rat1n rat2n)
'(rnlessp rat2 rat1)
(rnlessp rat2 rat1)
'(rnlessp rat2 rat1n)
(rnlessp rat2 rat1n)
'(rnlessp rat2n rat1)
(rnlessp rat2n rat1)
'(rnlessp rat2n rat1n)
(rnlessp rat2n rat1n)
'(rnlessp rat2 rat2)
(rnlessp rat2 rat2)
'(rnlessp rat2n rat2n)
(rnlessp rat2n rat2n)
'(rnlessp int1 int2)
(rnlessp int1 int2)
'(rnlessp int2n int1n)
(rnlessp int2n int1n)
'(rnlessp num1 num2)
(rnlessp num1 num2)
'(rnlessp num2 num1)
(rnlessp num2 num1)

'(rplus rat1 rat2)
(rplus rat1 rat2)
'(rplus rat1 rat2n)
(rplus rat1 rat2n)
'(rplus rat1n rat2)
(rplus rat1n rat2)
'(rplus rat1n rat2n)
(rplus rat1n rat2n)
'(rplus rat2 rat1)
(rplus rat2 rat1)
'(rplus rat2 rat1n)
(rplus rat2 rat1n)
'(rplus rat2n rat1)
(rplus rat2n rat1)
'(rplus rat2n rat1n)
(rplus rat2n rat1n)
'(rplus int1 int2)
(rplus int1 int2)
'(rplus int1 int2n)
(rplus int1 int2n)
'(rplus int1n int2)
(rplus int1n int2)
'(rplus int1n int2n)
(rplus int1n int2n)
'(rplus num1 num2)
(rplus num1 num2)
'(rplus num2 num1)
(rplus num2 num1)

'(rquotient rat1 rat2)
(rquotient rat1 rat2)
'(rquotient rat1 rat2n)
(rquotient rat1 rat2n)
'(rquotient rat1n rat2)
(rquotient rat1n rat2)
'(rquotient rat1n rat2n)
(rquotient rat1n rat2n)
'(rquotient rat2 rat1)
(rquotient rat2 rat1)
'(rquotient rat2 rat1n)
(rquotient rat2 rat1n)
'(rquotient rat2n rat1)
(rquotient rat2n rat1)
'(rquotient rat2n rat1n)
(rquotient rat2n rat1n)
'(rquotient int1 int2)
(rquotient int1 int2)
'(rquotient int1 int2n)
(rquotient int1 int2n)
'(rquotient int1n int2)
(rquotient int1n int2)
'(rquotient int1n int2n)
(rquotient int1n int2n)
'(rquotient int2 int1)
(rquotient int2 int1)
'(rquotient int2 int1n)
(rquotient int2 int1n)
'(rquotient int2n int1)
(rquotient int2n int1)
'(rquotient int2n int1n)
(rquotient int2n int1n)
'(rquotient num1 num2)
(rquotient num1 num2)
'(rquotient num2 num1)
(rquotient num2 num1)

'(rsquareroot '#1 '#0)
(rsquareroot '#1 '#0)
'(rsquareroot '#100 '#0)
(rsquareroot '#100 '#0)
'(rsquareroot '#2 '#0)
(rsquareroot '#2 '#0)
'(rsquareroot '#2 '#1)
(rsquareroot '#2 '#1)
'(rsquareroot '#2 '#3)
(rsquareroot '#2 '#3)

'(rtimes rat1 rat1)
(rtimes rat1 rat1)
'(rtimes rat2 rat2n)
(rtimes rat2 rat2n)
'(rtimes rat1n rat1)
(rtimes rat1n rat1)
'(rtimes rat2n rat2n)
(rtimes rat2n rat2n)
'(rtimes int1 int2)
(rtimes int1 int2)
'(rtimes int1n int2)
(rtimes int1n int2)
'(rtimes int1 int2n)
(rtimes int1 int2n)
'(rtimes int1n int2n)
(rtimes int1n int2n)
'(rtimes num1 num2)
(rtimes num1 num2)

'(sassoc 'viii alist (lambda() 'void))
(sassoc 'viii alist (lambda() 'void))
'(sassoc 'xxx alist (lambda() 'void))
(sassoc 'xxx alist (lambda() 'void))
'(sassoc 'xxx nil (lambda() 'void))
(sassoc 'xxx nil (lambda() 'void))

'(some '((a b c) x (d e f)) atom)
(some '((a b c) x (d e f)) atom)
'(some '((a b c) (d e f)) atom)
(some '((a b c) (d e f)) atom)
'(some () atom)
(some () atom)

'(sort nlist greaterp)
(sort nlist greaterp)
'(sort nlist lessp)
(sort nlist lessp)
'(sort nil lessp)
(sort nil lessp)

'(squareroot '#1)
(squareroot '#1)
'(squareroot '#4)
(squareroot '#4)
'(squareroot '#99)
(squareroot '#99)
'(squareroot '#-1)
(squareroot '#-1)

'(sublis alist '(((+ vi vii) (- x ix)) ((* ii iii) (/ viii iv))))
(sublis	alist '(((+ vi vii) (- x ix)) ((* ii iii) (/ viii iv))))
'(sublis alist nil)
(sublis	alist nil)
'(sublis nil '(((+ vi vii) (- x ix)) ((* ii iii) (/ viii iv))))
(sublis	nil '(((+ vi vii) (- x ix)) ((* ii iii) (/ viii iv))))

'(subst '(x x) '(j k) clist1)
(subst '(x x) '(j k) clist1)
'(subst '(x x) '(j k) xlist)
(subst '(x x) '(j k) xlist)
'(subst '(x x) '(j k) nil)
(subst '(x x) '(j k) nil)
'(subst nil 'xxx xlist)
(subst nil 'xxx xlist)

'(succ 5)
(succ 5)
'(succ 9)
(succ 9)

'(sum '#1 '#100)
(sum '#1 '#100)
'(sum '#+1 '#+100)
(sum '#+1 '#+100)
'(sum '#50 '#100)
(sum '#50 '#100)
'(sum '#-1 '#-10)
(sum '#-1 '#-10)
'(sum '#10 '#1)
(sum '#10 '#1)

'(tailp () '(a b c))
(tailp () '(a b c))
'(tailp '(d e f) '(a b c d e f))
(tailp '(d e f) '(a b c d e f))
'(tailp '(a b c) '(a b c))
(tailp '(a b c) '(a b c))
'(tailp '((b) (c) (d)) '((a) (b) (c) (d)))
(tailp '((b) (c) (d)) '((a) (b) (c) (d)))
'(tailp '(d e f g) '(a b c d e f))
(tailp '(d e f g) '(a b c d e f))

'(times num1 num2)
(times num1 num2)
'(times num2 num1)
(times num2 num1)
'(times num1 '(1))
(times num1 '(1))
'(times num1 '(0))
(times num1 '(0))

'(union set1 set2)
(union set1 set2)
'(union set1 nil)
(union set1 nil)
'(union nil set2)
(union nil set2)

'(unique (append set1 set1))
(unique (append set1 set1))
'(unique xlist)
(unique xlist)
'(unique (append nlist nlist))
(unique (append nlist nlist))
'(unique nil)
(unique nil)

'(unsort '(#1) '#1)
(unsort '(#1) '#1)
'(unsort (iota '#10) '#3)
(unsort (iota '#10) '#3)

'(zerop '(0))
(zerop '(0))
'(zerop '(1))
(zerop '(1))
'(zerop '(+ 0))
(zerop '(+ 0))
'(zerop '(- 0))
(zerop '(- 0))
'(zerop '(/ #2 #5))
(zerop '(/ #2 #5))
'(zerop '(/ #0 #5))
(zerop '(/ #0 #5))

:l ext/ext-tree.l
:l ext/ext-date.l
:l ext/fixed-point.l

'(date-after-p date1 date1)
(date-after-p date1 date1)
'(date-after-p date1 date2)
(date-after-p date1 date2)
'(date-after-p date2 date3)
(date-after-p date2 date3)
'(date-after-p date3 date4)
(date-after-p date3 date4)
'(date-after-p date1 date3)
(date-after-p date1 date3)
'(date-after-p date2 date4)
(date-after-p date2 date4)
'(date-after-p date1 date4)
(date-after-p date1 date4)

'(date-before-p date1 date1)
(date-before-p date1 date1)
'(date-before-p date1 date2)
(date-before-p date1 date2)
'(date-before-p date2 date3)
(date-before-p date2 date3)
'(date-before-p date3 date4)
(date-before-p date3 date4)
'(date-before-p date1 date3)
(date-before-p date1 date3)
'(date-before-p date2 date4)
(date-before-p date2 date4)
'(date-before-p date1 date4)
(date-before-p date1 date4)

'(date-difference date1 date1)
(date-difference date1 date1)
'(date-difference date1 date2)
(date-difference date1 date2)
'(date-difference date2 date3)
(date-difference date2 date3)
'(date-difference date3 date4)
(date-difference date3 date4)
'(date-difference date1 date3)
(date-difference date1 date3)
'(date-difference date2 date4)
(date-difference date2 date4)
'(date-difference date1 date4)
(date-difference date1 date4)

'(date-to-days '(#1 #1 #1))
(date-to-days '(#1 #1 #1))
'(date-to-days date1)
(date-to-days date1)
'(date-to-days date2)
(date-to-days date2)
'(date-to-days date3)
(date-to-days date3)
'(date-to-days date4)
(date-to-days date4)

'(fixed-point (rational '#1) '#3)
(fixed-point (rational '#1) '#3)
'(fixed-point (rational '#0) '#3)
(fixed-point (rational '#0) '#3)
'(fixed-point '(/ #1 #2) '#3)
(fixed-point '(/ #1 #2) '#3)
'(fixed-point '(/ #1 #3) '#3)
(fixed-point '(/ #1 #3) '#3)
'(fixed-point '(/ #12345 #7) '#10)
(fixed-point '(/ #12345 #7) '#10)
'(fixed-point '(/ #665857 #470832) '#10)
(fixed-point '(/ #665857 #470832) '#10)

'(tree-assoc '#1 atree lessp)
(tree-assoc '#1 atree lessp)
'(tree-assoc '#2 atree lessp)
(tree-assoc '#2 atree lessp)
'(tree-assoc '#3 atree lessp)
(tree-assoc '#3 atree lessp)
'(tree-assoc '#4 atree lessp)
(tree-assoc '#4 atree lessp)
'(tree-assoc '#5 atree lessp)
(tree-assoc '#5 atree lessp)
'(tree-assoc '#6 atree lessp)
(tree-assoc '#6 atree lessp)
'(tree-assoc '#7 atree lessp)
(tree-assoc '#7 atree lessp)
'(tree-assoc '#8 atree lessp)
(tree-assoc '#8 atree lessp)
'(tree-assoc '#9 atree lessp)
(tree-assoc '#9 atree lessp)

'(tree-balance olist lessp)
(tree-balance olist lessp)
'(tree-balance (tree-flatten tree) greaterp)
(tree-balance (tree-flatten tree) greaterp)
'(tree-balance (tree-flatten atree)
	(lambda (a b) (greaterp (car a) (car b))))
(tree-balance (tree-flatten atree)
	(lambda (a b) (greaterp (car a) (car b))))

'(tree-insert '#5 nil greaterp)
(define l* (tree-insert '#5 nil greaterp))
l*
'(tree-insert '#3 l* greaterp)
(define l* (tree-insert '#3 l* greaterp))
l*
'(tree-insert '#7 l* greaterp)
(define l* (tree-insert '#7 l* greaterp))
l*
'(tree-insert '#6 tree lessp)
(tree-insert '#6 tree lessp)

'(tree-flatten l*)
(tree-flatten l*)
'(tree-flatten tree)
(tree-flatten tree)
'(tree-flatten nil)
(tree-flatten nil)

'(tree-sort nlist lessp)
(tree-sort nlist lessp)
'(tree-sort nlist greaterp)
(tree-sort nlist greaterp)
'(tree-sort nil lessp)
(tree-sort nil lessp)
